/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G127
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "adc_demo.h"
#include "delay_demo.h"
#define ADC_ENABLE   1

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t   g_AdcIntTaken;

uint16_t get_value[8 * 2];


int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t width = 0, tempAdc;
    int i = 0, j = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);

    Uart0_Init(19200);

#if ADC_ENABLE
    /*the adc scans 4 adc channel and output adc result */
    Adc_Scan_Init();
    tempAdc = ADC_Converse_Scan(ADC_Channel_2, 8, get_value);

    for (i = 0; i < 8; i++)
    {
        printf("ADC Get Value = ");

        for (j = 0; j < 4; j++)
        {
            //printf("0x%04X, ", get_value[i][j]);
            printf("0x%04X, ", get_value[i * ADC_ScanNum_4 + j]);
        }

        printf("\n");
    }

#endif

}




