#include "dma_demo.h"
unsigned char CTRL_DATA_UART0 = 6;
unsigned char CTRL_DATA = 7;
/***********************************************************************************************************************
* Function Name: DMA_Uart0_Tx
* @brief  config DMA for uart tx
* @param  src_adr: dma source address
* @param  dst_adr: dma destine address
* @param  count: dma transform num
* @return None
***********************************************************************************************************************/
extern  volatile uint8_t   *sfr_addr;
void DMA_Uart0_Tx(DMA_VECTOR_t dma_vector, DMA_Mode_t mode, void *src_adr, void *dst_adr, uint16_t count)
{
    DMA_InitTypeDef  DMA_InitStructure = {0};


    DMA_InitStructure.DMA_Vector = dma_vector;    //ݹѡͬdma
    DMA_InitStructure.DMA_CtrlId = CTRL_DATA;     //ѡ
    DMA_InitStructure.DMA_SrcAddr = (uint32_t)src_adr;  //dmaԴַ
    DMA_InitStructure.DMA_DstAddr = (uint32_t)dst_adr;  //dmaĿַ
    DMA_InitStructure.DMA_BufferSize = count;
    DMA_InitStructure.DMA_SrcInc = DMA_SrcInc_Enable;//Դַģʽ
    DMA_InitStructure.DMA_DstInc = DMA_DstInc_Disable;//Ŀ̶ַ
    DMA_InitStructure.DMA_DataSize = DMA_DataSize_Byte;//ݳѡ
    DMA_InitStructure.DMA_Mode = mode;//ͨģʽ
	DMA_Init(&DMA_InitStructure);

	DMA_Start(DMA_InitStructure.DMA_Vector);
}

/***********************************************************************************************************************
* Function Name: DMA_Uart0_Rx
* @brief  config DMA for uart read
* @param  src_adr: dma source address
* @param  dst_adr: dma destine address
* @param  count: dma transform num
* @return None
***********************************************************************************************************************/
void DMA_Uart0_Rx(DMA_VECTOR_t dma_vector, DMA_Mode_t mode, void *src_adr, void *dst_adr, uint16_t count)
{
    DMA_InitTypeDef  DMA_InitStructure = {0};

    DMA_InitStructure.DMA_Vector = dma_vector;    //ݹѡͬdma
    DMA_InitStructure.DMA_CtrlId = CTRL_DATA_UART0;     //ѡ
    DMA_InitStructure.DMA_SrcAddr = (uint32_t)src_adr;  //dmaԴַ
    DMA_InitStructure.DMA_DstAddr = (uint32_t)dst_adr;  //dmaĿַ
    DMA_InitStructure.DMA_BufferSize = count;
    DMA_InitStructure.DMA_SrcInc = DMA_SrcInc_Disable;//Դ̶ַģʽ
    DMA_InitStructure.DMA_DstInc = DMA_DstInc_Enable;//Ŀַ
    DMA_InitStructure.DMA_DataSize = DMA_DataSize_Byte;//ݳѡ
    DMA_InitStructure.DMA_Mode = mode;
    DMA_InitStructure.DMA_RepeatAreaAddr = DMA_RepeatAreaAddr_Dst;//ģʽ£ظѡЧظģʽЧĿΪظ
    DMA_InitStructure.DMA_RepeatInt = DMA_RepeatInt_Disable;//ظģʽЧж
	DMA_Init(&DMA_InitStructure);

	DMA_Start(DMA_InitStructure.DMA_Vector);

}

