/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G127
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "common.h"
#include "gpio.h"
#include "cgc.h"
#include "pcbz.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORTB, GPIO_Pin_0, GROUP_AF_PCLBUZ0); // CLKBUZ0 can be alternative to any desired pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORTB, GPIO_Pin_1, GROUP_AF_PCLBUZ1); // CLKBUZ1 :P15 default Alternate function

    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTB, &GPIO_InitStruct);
	
	PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡclkbuz ͨ0
	PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
	PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_3;	
	PCBZ_Init(&PCBZ_InitStructure);	
	
    /*CLKBUZ1 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTB, &GPIO_InitStruct);
	
	PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_1;  //ѡclkbuz ͨ1
	PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FSUB;
	PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FSUB_0;	
	PCBZ_Init(&PCBZ_InitStructure);		
}
int main()
{
	
/*ⲿϵͳʱΪcpuʱԼΧ·ʱӣͬʱⲿϵͳʱΪʱ*/
	CGC_Osc_Setting(OSC_OSCILLATOR,OSC_UNDER_10M,OSC_OSCILLATOR,OSC_NORMAL_POWER);
	CGC_HSE_CFG_AS_FCLK();  //ⲿϵͳʱΪcpuʱԼΧ·ʱ

	
	PCBZIO_Init();	   

}



