#include "dma_demo.h"
#include "spi.h"
#include "cgc.h"

unsigned int CTRL_DATA_SPI10 = 5;
unsigned int CTRL_DATA_SPI11 = 6;



/***********************************************************************************************************************
* Function Name: Dma_Config
* @brief  config DMA for spi write
* @param  src_adr: dma source address
* @param  dst_adr: dma destine address
* @param  count: dma transform num
* @return None
***********************************************************************************************************************/
void Dma_Adc_Config(DMA_VECTOR_t dma_vector, DMA_Mode_t mode, void *src_adr, void *dst_adr, uint16_t count)
{
    DMA_InitTypeDef  DMA_InitStructure = {0};
    unsigned int CTRL_DATA_ADC = 0;

    DMA_InitStructure.DMA_Vector = dma_vector;    //ݹѡͬdma
    DMA_InitStructure.DMA_CtrlId = CTRL_DATA_ADC;     //ѡ
    DMA_InitStructure.DMA_SrcAddr = (uint32_t)src_adr;  //dmaԴַ
    DMA_InitStructure.DMA_DstAddr = (uint32_t)dst_adr;  //dmaĿַ
    DMA_InitStructure.DMA_BufferSize = count;
    DMA_InitStructure.DMA_SrcInc = DMA_SrcInc_Disable;//Դ̶ַģʽ
    DMA_InitStructure.DMA_DstInc = DMA_DstInc_Enable;//Ŀַ ѭģʽЧ
    DMA_InitStructure.DMA_DataSize = DMA_DataSize_HalfWord;//ݳѡ.16bit
    DMA_InitStructure.DMA_Mode = mode;//ѭģʽ
    DMA_InitStructure.DMA_RepeatAreaAddr = DMA_RepeatAreaAddr_Dst;//ĿΪظ
    DMA_InitStructure.DMA_RepeatInt = DMA_RepeatInt_Enable;//ظģʽ£ж
	DMA_Init(&DMA_InitStructure);

	DMA_Start(DMA_InitStructure.DMA_Vector);
}

/***********************************************************************************************************************
* Function Name: Dma_Config
* @brief  config DMA for spi write
* @param  src_adr: dma source address
* @param  dst_adr: dma destine address
* @param  count: dma transform num
* @return None
***********************************************************************************************************************/
void Dma_Config(DMA_VECTOR_t dma_vector, uint8_t ctrl_data, DMA_Mode_t mode, void *src_adr, void *dst_adr, uint16_t count)
{
    DMA_InitTypeDef  DMA_InitStructure = {0};

    DMA_InitStructure.DMA_Vector = dma_vector;    //ݹѡͬdma
    DMA_InitStructure.DMA_CtrlId = ctrl_data;     //ѡ
    DMA_InitStructure.DMA_SrcAddr = (uint32_t)src_adr;  //dmaԴַ
    DMA_InitStructure.DMA_DstAddr = (uint32_t)dst_adr;  //dmaĿַ
    DMA_InitStructure.DMA_BufferSize = count;
    DMA_InitStructure.DMA_SrcInc = DMA_SrcInc_Enable;//Դַģʽ
    DMA_InitStructure.DMA_DstInc = DMA_DstInc_Disable;//Ŀ̶ַ
    DMA_InitStructure.DMA_DataSize = DMA_DataSize_Byte;//ݳѡ
    DMA_InitStructure.DMA_Mode = mode;//ͨģʽ

	DMA_Init(&DMA_InitStructure);

	DMA_Start(DMA_InitStructure.DMA_Vector);
}


/***********************************************************************************************************************
* Function Name: Dma_Config1
* @brief  config DMA for spi read
* @param  src_adr: dma source address
* @param  dst_adr: dma destine address
* @param  count: dma transform num
* @return None
***********************************************************************************************************************/
void Dma_Config1(DMA_VECTOR_t dma_vector, uint8_t ctrl_data, DMA_Mode_t mode, void *src_adr, void *dst_adr, uint16_t count)
{
    DMA_InitTypeDef  DMA_InitStructure = {0};
    static uint8_t dummy_sio11 = 0xFEU;
    /* read receive data with DMA */
    DMA_InitStructure.DMA_Vector = dma_vector;
    DMA_InitStructure.DMA_CtrlId = ctrl_data;
    DMA_InitStructure.DMA_SrcAddr = (uint32_t)src_adr;  //dmaԴַ
    DMA_InitStructure.DMA_DstAddr = (uint32_t)dst_adr;  //dmaĿַ
    DMA_InitStructure.DMA_BufferSize = count;
    DMA_InitStructure.DMA_SrcInc = DMA_SrcInc_Disable;//Դ̶ַģʽ
    DMA_InitStructure.DMA_DstInc = DMA_DstInc_Enable;//Ŀַģʽ
    DMA_InitStructure.DMA_DataSize = DMA_DataSize_Byte;//ݳѡ
    DMA_InitStructure.DMA_Mode = mode; //ͨģʽ
	DMA_Init(&DMA_InitStructure);

	DMA_Start(DMA_InitStructure.DMA_Vector);
}

/***********************************************************************************************************************
* Function Name: DMA_Spi_WriteRead
* @brief  config DMA for spi read
* @param  src_adr: dma source address
* @param  dst_adr: dma destine address
* @param  count: dma transform num
* @return None
***********************************************************************************************************************/
void DMA_Spi_WriteRead(DMA_VECTOR_t dma_vector, uint8_t ctrl_data, DMA_Mode_t mode, void *src_adr, void *dst_adr, uint16_t count)
{
    DMA_InitTypeDef  DMA_InitStructure = {0};

    /* read receive data with DMA */
    DMA_InitStructure.DMA_Vector = dma_vector;
    DMA_InitStructure.DMA_CtrlId = ctrl_data;
    DMA_InitStructure.DMA_SrcAddr = (uint32_t)src_adr;  //dmaԴַ
    DMA_InitStructure.DMA_DstAddr = (uint32_t)&SPI_WRDR;  //dmaĿַ
    DMA_InitStructure.DMA_BufferSize = count;
    DMA_InitStructure.DMA_SrcInc = DMA_SrcInc_Enable;//Դַģʽ
    DMA_InitStructure.DMA_DstInc = DMA_DstInc_Disable;//Ŀ̶ַģʽ
    DMA_InitStructure.DMA_DataSize = DMA_DataSize_Byte;//ݳѡ
    DMA_InitStructure.DMA_Mode = mode; //ͨģʽ
    DMA_InitStructure.DMA_ChainTrans = DMA_ChainTrans_Head; //ͷڵ
	
    DMA_Init(&DMA_InitStructure); 
    /* write dummy transfer data with DMA */
    DMA_InitStructure.DMA_CtrlId = ctrl_data + 1;
    DMA_InitStructure.DMA_SrcAddr = (uint32_t)&SPI_RDDR;  //dmaԴַ
    DMA_InitStructure.DMA_DstAddr = (uint32_t)dst_adr;  //dmaĿַ
    DMA_InitStructure.DMA_BufferSize = count;
    DMA_InitStructure.DMA_SrcInc = DMA_SrcInc_Disable;//Դ̶ַģʽ
    DMA_InitStructure.DMA_DstInc = DMA_DstInc_Enable;//Ŀַģʽ
    DMA_InitStructure.DMA_DataSize = DMA_DataSize_Byte;//ݳѡ
    DMA_InitStructure.DMA_Mode = mode; //ͨģʽ
    DMA_InitStructure.DMA_ChainTrans = DMA_ChainTrans_Tail; //βڵ
	
	DMA_Init(&DMA_InitStructure);
	DMA_Start(DMA_InitStructure.DMA_Vector);
}
