/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : iic_demo.c                                                   *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "iic_demo.h"

volatile uint8_t g_iic_tx_end;                /* iic send data end */
volatile uint8_t g_iic_rx_end;                /* iic receive data end */

void Iic00_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    IIC_InitTypeDef  IIC_InitStructure = {0};
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT3, GPIO_Pin_0, GPIO_P30, GROUP_AF_SCKO00); //SCL00 allocated to any desired pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT5, GPIO_Pin_0, GPIO_P50, GROUP_AF_SDA00); //SDA00 allocated to any desired pins with PxxCFG register

    /*SCL00 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT3, &GPIO_InitStruct);

    /*SDA00 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT5, &GPIO_InitStruct);

    IIC_InitStructure.IIC_Prescaler = FCLK_DIV_1;   //ѡIICʱfmclk
    IIC_InitStructure.IIC_Prescaler_Devide = 39;    //ͨͺͽʱfmclk/(Devide+1)/2= 32M/40/2=400KHz
    IIC_InitStructure.IIC_Int = IIC_Int_Enable;     //iicշж

    ISR_InitStructure.IRQ_Channel = IIC00_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = iic01_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    SCI_IIC_Init(IIC00_SCI, &IIC_InitStructure);
}
void Iic01_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    IIC_InitTypeDef  IIC_InitStructure = {0};
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_5, GPIO_P75, GROUP_AF_ODEFAULT); //P75 default function SCL01
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_4, GPIO_P74, GROUP_AF_ODEFAULT); //P74 default function SDA01

    /*SCL01 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    /*SDA01 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    IIC_InitStructure.IIC_Prescaler = FCLK_DIV_1;   //ѡIICʱfmclk
    IIC_InitStructure.IIC_Prescaler_Devide = 39;    //ͨͺͽʱfmclk/(Devide+1)/2= 32M/40/2=400KHz
    IIC_InitStructure.IIC_Int = IIC_Int_Enable;     //iicշж

    ISR_InitStructure.IRQ_Channel = IIC01_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = iic01_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    SCI_IIC_Init(IIC01_SCI, &IIC_InitStructure);
}
void Iic10_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    IIC_InitTypeDef  IIC_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT13, GPIO_Pin_0, GPIO_P130, GROUP_AF_ODEFAULT); //P130  default function SCL10
    GPIO_PinAFConfig(GPIO_PORT0, GPIO_Pin_1, GPIO_P01, GROUP_AF_SDA10); // SDA10 allocated to any desired pins with PxxCFG register

    /*SCL10 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT13, &GPIO_InitStruct);

    /*SDA10 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT0, &GPIO_InitStruct);


    IIC_InitStructure.IIC_Prescaler = FCLK_DIV_1;               //ѡIICʱfmclk
    IIC_InitStructure.IIC_Prescaler_Devide = 39;  //ͨͺͽʱfmclk/(Devide+1)/2= 32M/40/2=400KHz
    SCI_IIC_Init(IIC10_SCI, &IIC_InitStructure);

    ISR_InitStructure.IRQ_Channel = IIC10_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = iic01_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

}
void Iic11_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    IIC_InitTypeDef  IIC_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_0, GPIO_P10, GROUP_AF_ODEFAULT); //P10  default function SCL11
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_1, GPIO_P11, GROUP_AF_ODEFAULT); //P10  default function SDA11

    /*SCL11 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDA11 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);


    IIC_InitStructure.IIC_Prescaler = FCLK_DIV_1;               //ѡIICʱfmclk
    IIC_InitStructure.IIC_Prescaler_Devide = 39;  //ͨͺͽʱfmclk/(Devide+1)/2= 32M/40/2=400KHz
    SCI_IIC_Init(IIC11_SCI, &IIC_InitStructure);

    ISR_InitStructure.IRQ_Channel = IIC11_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = iic01_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);
}

void Iic20_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    IIC_InitTypeDef  IIC_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_5, GPIO_P15, GROUP_AF_SCKO20); //SCL20 to any desired pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_4, GPIO_P14, GROUP_AF_ODEFAULT); //P14 default function SDA20

    /*SCL20 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDA20 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);


    IIC_InitStructure.IIC_Prescaler = FCLK_DIV_1; //ѡIICʱfmclk
    IIC_InitStructure.IIC_Prescaler_Devide = 39;  //ͨͺͽʱfmclk/(Devide+1)/2= 32M/40/2=400KHz

    ISR_InitStructure.IRQ_Channel = IIC20_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = iic01_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    SCI_IIC_Init(IIC20_SCI, &IIC_InitStructure);
}

void Iic21_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    IIC_InitTypeDef  IIC_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_0, GPIO_P70, GROUP_AF_ODEFAULT); //P70  default function SCL21
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_1, GPIO_P71, GROUP_AF_ODEFAULT); //P71  default function SDA20

    /*SCL21 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    /*SDA21 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);


    IIC_InitStructure.IIC_Prescaler = FCLK_DIV_1; //ѡIICʱfmclk
    IIC_InitStructure.IIC_Prescaler_Devide = 39;  //ͨͺͽʱfmclk/(Devide+1)/2= 32M/40/2=400KHz

    ISR_InitStructure.IRQ_Channel = IIC21_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = iic01_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    SCI_IIC_Init(IIC21_SCI, &IIC_InitStructure);
}
/***********************************************************************************************************************
* Function Name: IIC_WriteBuff
* @brief  This function starts transferring data using polling way for IIC in master mode
* @param  adr - set address for select slave
* @param  reg - set register for write data
* @param  tx_buf - transfer buffer pointer
* @param  len - buffer size
* @return None
***********************************************************************************************************************/
void IIC_WriteBuff(SCIAFSelect_TypeDef func, uint8_t address, uint8_t Reg, uint8_t *Bufp, uint8_t len)
{
    IRQn_Type irq_Chanel;

    Sci_RegSetting(func);     // iic registor mapping
    irq_Chanel = sci_reg.IRQn;
    *sci_reg.SCR &= (uint16_t) ~(SCI_RECEPTION_TRANSMISSION);
    *sci_reg.SCR |= SCI_TRANSMISSION;

    SCI_IIC_StartCondition(func);  //iic start signal

    *sci_reg.SIO = address & 0xFE; //device address RW=0

    while (!INTC_GetPendingIRQ(irq_Chanel));

    INTC_ClearPendingIRQ(irq_Chanel);

    *sci_reg.SIO = Reg;//Registor

    while (!INTC_GetPendingIRQ(irq_Chanel));

    INTC_ClearPendingIRQ(irq_Chanel);

    do
    {
        *sci_reg.SIO = *Bufp++;//Data

        while (!INTC_GetPendingIRQ(irq_Chanel));

        INTC_ClearPendingIRQ(irq_Chanel);
    } while (--len);

    SCI_IIC_StopCondition(func);  //iic stop signal
    SCI_IIC_Stop(func);
}

/***********************************************************************************************************************
* Function Name: IIC_ReadBuff
* @brief  This function starts to read data using polling way for IIC in master mode
* @param  adr - set address for select slave
* @param  reg - set register for read data
* @param  tx_buf - transfer buffer pointer
* @param  len - read buffer size
* @return None
***********************************************************************************************************************/
void IIC_ReadBuff(SCIAFSelect_TypeDef func, uint8_t I2c_Add, uint8_t Reg, uint8_t *Bufp, uint8_t len)
{
    uint32_t delayUS;
    IRQn_Type irq_Chanel;
    Sci_RegSetting(func);     // iic registor mapping
    irq_Chanel = sci_reg.IRQn;
    *sci_reg.SCR &= (uint16_t) ~(SCI_RECEPTION_TRANSMISSION);
    *sci_reg.SCR |= SCI_TRANSMISSION;

    SCI_IIC_StartCondition(func);  //iic start signal

    *sci_reg.SIO = I2c_Add & 0xFE; //device address RW=0

    while (!INTC_GetPendingIRQ(irq_Chanel));

    INTC_ClearPendingIRQ(irq_Chanel);

    *sci_reg.SIO = Reg;//Registor

    while (!INTC_GetPendingIRQ(irq_Chanel));

    INTC_ClearPendingIRQ(irq_Chanel);

    SCI_IIC_StopCondition(func);  //iic stop signal: iic write address and registor finished

    delayUS = 16;

    while (--delayUS);

    SCI_IIC_StartCondition(func);  //iic start signal: iic read start

    *sci_reg.SIO = I2c_Add | 0x01; //device address RW=1

    while (!INTC_GetPendingIRQ(irq_Chanel));

    INTC_ClearPendingIRQ(irq_Chanel);

    *sci_reg.ST |= (0x000F & (uint16_t)func);
    *sci_reg.SCR &= (uint16_t)~(SCI_RECEPTION_TRANSMISSION);
    *sci_reg.SCR |= SCI_RECEPTION;
    *sci_reg.SS |= 0x0002;//start operation

    do
    {
        if (len == 1U)
        {
            *sci_reg.SOE &= (uint16_t)~0x0002;//allow output enable
        }

        *sci_reg.SIO = 0xFFU;//dummy

        while (!INTC_GetPendingIRQ(irq_Chanel));

        INTC_ClearPendingIRQ(irq_Chanel);

        *Bufp++ = *sci_reg.SIO;//read data

    } while (--len);

    SCI_IIC_StopCondition(func);  //iic stop signal
    SCI_IIC_Stop(func);
}

/***********************************************************************************************************************
* Function Name: Iic_Write
* @brief  This function starts transferring data for IIC in master mode.
* @param  adr - set address for select slave
* @param  tx_buf - transfer buffer pointer
* @param  tx_num - buffer size
* @return None
***********************************************************************************************************************/
void Iic_Write(SCIAFSelect_TypeDef func, uint8_t address, uint8_t *tx_buf, uint16_t tx_num)
{
    pData.flag = INT_IDLE;
    address &= 0xFE;    //iic write flag
    pData.flag = INT_TX;

    Sci_RegSetting(func);     // iic registor mapping

    *sci_reg.SCR &= (uint16_t) ~(SCI_RECEPTION_TRANSMISSION);
    *sci_reg.SCR &= SCI_TRANSMISSION;

    SCI_IIC_StartCondition(func);  //iic start signal

    INTC_ClearPendingIRQ(sci_reg.IRQn); // clear INTIIC01 interrupt flag
    NVIC_ClearPendingIRQ(sci_reg.IRQn); // clear INTIIC01 interrupt flag
    INTC_EnableIRQ(sci_reg.IRQn);       // enable INTIIC01 interrupt flag
    *sci_reg.SIO = address;

    pData.flag = INT_TX;
    pData.data = tx_buf;    //send buffer pointer
    pData.len  = tx_num;    //set send data count

}
/***********************************************************************************************************************
* Function Name: Iic_Read
* @brief  This function starts receiving data for IIC in master mode.
* @param  adr - set address for select slave
* @param  rx_buf - receive buffer pointer
* @param  rx_num - buffer size
* @return None
***********************************************************************************************************************/
void Iic_Read(SCIAFSelect_TypeDef func, uint8_t address, uint8_t *rx_buf, uint16_t rx_num)
{
    pData.flag = INT_IDLE;
    address |= 0x01;    //iic read flag
    pData.flag = INT_RX;

    Sci_RegSetting(func);     // iic registor mapping
    *sci_reg.SCR &= (uint16_t) ~(SCI_RECEPTION_TRANSMISSION);
    *sci_reg.SCR &= SCI_TRANSMISSION;

    SCI_IIC_StartCondition(func);  //iic start signal

    INTC_ClearPendingIRQ(sci_reg.IRQn); // clear INTIIC01 interrupt flag
    NVIC_ClearPendingIRQ(sci_reg.IRQn); // clear INTIIC01 interrupt flag
    INTC_EnableIRQ(sci_reg.IRQn);       // enable INTIIC01 interrupt flag
    *sci_reg.SIO = address;

    pData.flag = INT_RX;
    pData.data = rx_buf;    //send buffer pointer
    pData.len  = rx_num;    //set send data count

}

static void iic_callback_master_error(uint8_t flag)
{
    /* Start user code. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}

void iic01_interrupt(void *msg)
{
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    static uint16_t g_iic_rx_count = 0;
    SCIAFSelect_TypeDef func = IIC20_SCI;
    Sci_RegSetting(func);

    if (((*sci_reg.SSR & SCI_PARITY_ERROR) == 0x0002U) && (pFrame->len != 0))
    {
        iic_callback_master_error(IIC_NO_ACK); // NO IIC ACK is received
    }
    else if (((*sci_reg.SSR & SCI_OVERRUN_ERROR) == 0x0001) && (pFrame->len != 0))
    {
        iic_callback_master_error(IIC_OVF_RUN);
    }
    else/* IIC ACK is received*/
    {
        /* Control for master send */
        if (pFrame->flag == INT_TX)
        {
            if (pFrame->len > 0U)
            {
                *sci_reg.SIO = *pFrame->data;
                pFrame->data++;
                pFrame->len--;
            }
            else //IIC01 finishes master transmission
            {
                SCI_IIC_StopCondition(func);  //iic stop signal
                SCI_IIC_Stop(func);
                g_iic_tx_end = 1;
            }
        }
        else  // Control for master receive
        {
            if ((pFrame->flag & SCI_IIC_SENDADR) == 0)
            {
                *sci_reg.ST |= 0x0F & ((uint8_t)func);//Stop channel
                *sci_reg.SCR &= (uint16_t)~(SCI_RECEPTION_TRANSMISSION);
                *sci_reg.SCR |= SCI_RECEPTION;
                *sci_reg.SS |= 0x0F & ((uint8_t)func);//_0002_SCI_CH1_START_TRG_ON
                pFrame->flag |= SCI_IIC_SENDADR;

                if (pFrame->len == 1)
                {
                    *sci_reg.SOE &= (uint16_t)~(0x0F & ((uint8_t)func)); //disable output
                }

                *sci_reg.SIO = 0xFFU;
            }
            else
            {
                if (g_iic_rx_count < pFrame->len)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->data++;
                    g_iic_rx_count++;

                    if (g_iic_rx_count == (pFrame->len - 1))
                    {
                        *sci_reg.SOE &= (uint16_t)~~(0x0F & ((uint8_t)func));//SCI_CHANNEL_OUTPUT_ENABLE
                        *sci_reg.SIO = 0xFFU;
                    }
                    else if (g_iic_rx_count == pFrame->len)
                    {
                        SCI_IIC_StopCondition(func);
                        SCI_IIC_Stop(func);
                        g_iic_rx_end = 1;
                    }
                    else
                    {
                        *sci_reg.SIO = 0xFFU;
                    }
                }
            }
        }
    }
}
