/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : spi_demo.c                                                 *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "spi_demo.h"
#include "dma_demo.h"
/***********************************************************************************************************************
* Function Name: Spi0_Init
* @brief simple spi init
* @param
* @return  status
***********************************************************************************************************************/
void NSS_set()
{
    GPIO_SetBits(GPIO_PORT6, GPIO_Pin_2);
}
void NSS_clr()
{
    GPIO_ResetBits(GPIO_PORT6, GPIO_Pin_2);
}
int Spi00_Init(void)
{
    int res;
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS00 can be disired to any pins GROUP_AF_SS00
    GPIO_PinAFConfig(GPIO_PORT3, GPIO_Pin_0, GPIO_P30, GROUP_AF_SCKO00); // SCLK_OUTPUT can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT5, GPIO_Pin_1, GPIO_P51, GROUP_AF_SDO00); // MOSI(SDO00) can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT5, GPIO_Pin_0, GPIO_P50, GROUP_AF_SDI00); // MSIO(SDI00) can be disired to any pins

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT3, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT5, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT5, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                  //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;       //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;     //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_Prescaler = FCLK_DIV_16;         //ѡspiʱ    fmclk =clk/2^4
    SPI_InitStructure.SPI_Prescaler_Devide = 0;             //ͨͺͽʱfmclk/2^3
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;          //ѡbitȴ
    SPI_InitStructure.SPI_Int_Occur = SPI_Trans_End;       //ڴʱ,ж

    ISR_InitStructure.IRQ_Channel = SPI00_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = spi00_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    res = SCI_SPI_Init(SPI00_SCI, &SPI_InitStructure);
    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    if (res)
    {
        return res;
    }

    return SCI_SUCCESS;
}

int Spi10_Init(void)
{
    int res;
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS10 can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT13, GPIO_Pin_0, GPIO_P130, GROUP_AF_ODEFAULT); // SCLK_OUTPUT can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT0, GPIO_Pin_0, GPIO_P00, GROUP_AF_SDO10); // MOSI(SDO10) can be disired to any pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT0, GPIO_Pin_1, GPIO_P01, GROUP_AF_SDI10); // MSIO(SDI10) can be disired to any pins with SDI10PCFG register

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT13, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT0, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT0, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                  //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;             //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;          //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_Prescaler = FCLK_DIV_16;               //ѡspiʱ  fmclk =clk/2^4
    SPI_InitStructure.SPI_Prescaler_Devide = 0;                 //ͨͺͽʱfmclk/2^3
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ
    SPI_InitStructure.SPI_Int_Occur = SPI_Trans_End;           //ڴʱ,ж
    SPI_InitStructure.SPI_Int = SPI_Int_Enable;

    ISR_InitStructure.IRQ_Channel = SPI10_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = spi10_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    res = SCI_SPI_Init(SPI10_SCI, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز
    return SCI_SUCCESS;
}

int Spi11_Init(void)
{
    int res;
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS10 can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_0, GPIO_P10, GROUP_AF_ODEFAULT); // SCLK11_OUTPUT default fuction with P10
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_2, GPIO_P12, GROUP_AF_ODEFAULT); // MOSI(SDO11) default fuction with P12
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_1, GPIO_P11, GROUP_AF_ODEFAULT); // MSIO(SDI11) default fuction with P11

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                  //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;             //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;          //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_Prescaler = FCLK_DIV_16;               //ѡspiʱ  fmclk =clk/2^4
    SPI_InitStructure.SPI_Prescaler_Devide = 0;                 //ͨͺͽʱfmclk/2^3
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ
    SPI_InitStructure.SPI_Int_Occur = SPI_Trans_End;           //ڴʱ,ж
    SPI_InitStructure.SPI_Int = SPI_Int_Enable;

    ISR_InitStructure.IRQ_Channel = SPI11_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = spi11_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    res = SCI_SPI_Init(SPI11_SCI, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    NSS.Active = NSS_clr;                             //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز
    return SCI_SUCCESS;
}

int Spi20_Init(void)
{
    int res;
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_3, GPIO_P63, GROUP_AF_ODEFAULT); //SS20 can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_5, GPIO_P15, GROUP_AF_SCKO20); // SCLK20_OUTPUT can be disired to any pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_3, GPIO_P13, GROUP_AF_SDO20); // MOSI(SDO20)  can be disired to any pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_4, GPIO_P14, GROUP_AF_SDI20); // MSIO(SDI20) can be disired to any pins with SDI20PCFG register

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                  //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;             //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;          //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_Prescaler = FCLK_DIV_16;               //ѡspiʱ  fmclk =clk/2^4
    SPI_InitStructure.SPI_Prescaler_Devide = 0;                 //ͨͺͽʱfmclk/2^3
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ
    SPI_InitStructure.SPI_Int_Occur = SPI_Trans_End;           //ڴʱ,ж

    ISR_InitStructure.IRQ_Channel = SPI20_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = spi20_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    res = SCI_SPI_Init(SPI20_SCI, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    return SCI_SUCCESS;
}
int Spi21_Init(void)
{
    int res;
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStructure;
    ISR_InitTypeDef_t ISR_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_3, GPIO_P63, GROUP_AF_ODEFAULT); //SS21 can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_0, GPIO_P70, GROUP_AF_ODEFAULT); // SCLK21_OUTPUT default function with P70
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_2, GPIO_P72, GROUP_AF_ODEFAULT); // MOSI(SDO21) default function with P72
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_1, GPIO_P71, GROUP_AF_ODEFAULT); // MSIO(SDI20) default function with P71

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                  //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;             //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;          //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_Prescaler = FCLK_DIV_16;               //ѡspiʱ  fmclk =clk/2^4
    SPI_InitStructure.SPI_Prescaler_Devide = 0;                 //ͨͺͽʱfmclk/2^3
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ
    SPI_InitStructure.SPI_Int_Occur = SPI_Trans_End;           //ڴʱ,ж

    ISR_InitStructure.IRQ_Channel = SPI21_IRQn;
    ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = spi21_interrupt;//жϷ·ע
    ISR_Init(&ISR_InitStructure);

    res = SCI_SPI_Init(SPI21_SCI, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    return SCI_SUCCESS;
}
/***********************************************************************************************************************
* Function Name: Spi_Write
* @brief  spi write data
* @param  None
* @return None
***********************************************************************************************************************/
void Spi_Write(SCIAFSelect_TypeDef func, uint8_t tx_data)
{
    volatile uint8_t dummy;

    Sci_RegSetting(func);

    *sci_reg.SCR &= ~SCI_RECEPTION_TRANSMISSION;
    *sci_reg.SCR |= SCI_TRANSMISSION;

    *sci_reg.SIO = tx_data;

    while (*sci_reg.SSR & SCI_UNDER_EXECUTE);

    dummy = *sci_reg.SIO;

}

/***********************************************************************************************************************
* Function Name: Spi_Read
* @brief  spi read data
* @param  None
* @return None
***********************************************************************************************************************/
uint8_t Spi_Read(SCIAFSelect_TypeDef func)
{
    uint8_t temp;

    Sci_RegSetting(func);

    *sci_reg.SCR &= ~SCI_RECEPTION_TRANSMISSION;
    *sci_reg.SCR |= SCI_RECEPTION;

    *sci_reg.SIO = 0xFF;

    while (*sci_reg.SSR & SCI_VALID_STORED); //ssr6λ(1:Ч)

    temp = *sci_reg.SIO;

    return temp;
}

/***********************************************************************************************************************
* Function Name: Spi_Int_Write
* @brief  spi write data by interrupt,it can be used in the condition of master write or slave write
* @param  None
* @return None
***********************************************************************************************************************/
void Spi_Int_Write(SCIAFSelect_TypeDef func, uint8_t *tx_buf, uint16_t tx_num)
{
    Sci_RegSetting(func);

    *sci_reg.SCR &= ~SCI_RECEPTION_TRANSMISSION;
    *sci_reg.SCR |= SCI_TRANSMISSION;  //enable write

    SCI_SPI_Start(func);
#if 0 /*user can use SIO to trigger interrupt*/
    *sci_reg.SIO = *tx_buf;
    tx_buf++;
    tx_num--;
#endif
    pData.data = tx_buf;    //send buffer pointer
    pData.len  = tx_num;  //set send data count
    pData.flag = INT_TX;   //set data direction
    INTC_SetPendingIRQ(sci_reg.IRQn);
}

/***********************************************************************************************************************
* Function Name: Spi_Int_Read
* @brief  spi read data by interrupt,it can be used in the condition of master write or slave write
* @param  None
* @return None
***********************************************************************************************************************/
void Spi_Int_Read(SCIAFSelect_TypeDef func, uint8_t *rx_buf, uint16_t rx_num)
{
    Sci_RegSetting(func);

    *sci_reg.SCR &= ~SCI_RECEPTION_TRANSMISSION;
    *sci_reg.SCR |= SCI_RECEPTION;  //enable read

    SCI_SPI_Start(func);

    pData.data = rx_buf;   //read buffer pointer
    pData.len  = rx_num;   //set receive data count
    pData.flag = INT_RX;   //set data direction
    //  *sci_reg.SIO  = 0xFF;    //user can use SIO to trigger interrupt
    INTC_SetPendingIRQ(sci_reg.IRQn);
}

/***********************************************************************************************************************
* Function Name: Spi_Dma_Write
* @brief  spi write data by dma
* @param  None
* @return None
***********************************************************************************************************************/
void Spi_Dma_Write(SCIAFSelect_TypeDef func, uint8_t *tx_buf, uint16_t tx_num)
{
    Sci_RegSetting(func);

    *sci_reg.SCR &= ~SCI_RECEPTION_TRANSMISSION;
    *sci_reg.SCR |= SCI_TRANSMISSION;

    SCI_SPI_Start(func);

    Dma_Config(tx_buf, (void *)sci_reg.SIO, tx_num); //config dma transmission

    if (func == SPI00_SCI)
    {
        DMA_Trigger(DMA_VECTOR_SPI00);
    }
    else if (func == SPI01_SCI)
    {
        DMA_Trigger(DMA_VECTOR_SPI01);
    }
    else if (func == SPI10_SCI)
    {
        DMA_Trigger(DMA_VECTOR_SPI10);
    }
    else if (func == SPI11_SCI)
    {
        DMA_Trigger(DMA_VECTOR_SPI11);
    }
    else if (func == SPI20_SCI)
    {
        DMA_Trigger(DMA_VECTOR_SPI20);
    }
    else
    {
        DMA_Trigger(DMA_VECTOR_SPI21);
    }

#if 0   /*if you want to use interrput to trigger dma*/
    Dma_Config(tx_buf + 1, (void *)sci_reg.SIO, tx_num - 1); //config dma transmission

    *sci_reg.SIO = tx_buf[0];   //send finished will occur intterupt
    tx_buf++ ;

    pData.data = tx_buf;    //send buffer pointer
    pData.len  = 0;  //set send data count
    pData.flag = INT_TX;   //set data direction
#endif

}

/***********************************************************************************************************************
* Function Name: Spi_Dma_Read
* @brief  spi read data by dma
* @param  None
* @return None
***********************************************************************************************************************/
void Spi_Dma_Read(SCIAFSelect_TypeDef func, uint8_t *rx_buf, uint16_t rx_num)
{
    static uint8_t dummy_sio11 = 0xFEU;

    *sci_reg.SCR &= ~SCI_RECEPTION_TRANSMISSION;
    *sci_reg.SCR |= SCI_RECEPTION;

    SCI_SPI_Start(func);

    Dma_Config1((void *)sci_reg.SIO, rx_buf, rx_num - 1); //config dma transmission

    *sci_reg.SIO = dummy_sio11;

    pData.data = rx_buf + rx_num - 1; //read buffer pointer
    pData.len  = 1;   //set receive data count
    pData.flag = INT_RX;   //set data direction
}

/***********************************************************************************************************************
* Function Name: spi0_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi00_interrupt(void *msg)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    SCIAFSelect_TypeDef func = SPI00_SCI;

    Sci_RegSetting(func);
    err_type = (uint8_t)(*sci_reg.SSR & SCI_OVERRUN_ERROR);
    *sci_reg.SIR = err_type;

    INTC_ClearPendingIRQ(sci_reg.IRQn);


    if (1U == err_type)
    {
        //error condition
    }
    else
    {
        if (pFrame->flag == INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    *sci_reg.SIO = *pFrame->data;
                    pFrame->data++;
                    pFrame->len--;
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if (((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) != 0) && ((*sci_reg.SCR & SCI_RECEPTION) != 0))//slave mode :sclk is inputed by master clk
                    {
                        ;// when in slave mode ,do not need to wait end
                    }
                    else
                    {
                        while (*sci_reg.SSR & SCI_UNDER_EXECUTE) //waitting conmunction end, if register ST turns 1,or SS turns 1
                        {;}
                    }
                }

                SCI_SPI_Stop(func);
            }
        }

        if (pFrame->flag == INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                if ((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) == 0)
                {
                    *sci_reg.SIO = 0xFFU;   // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {

                while ((*sci_reg.SSR & SCI_VALID_STORED) == 0) // wait last data stored in register SDR
                {
                    ;
                }

                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                SCI_SPI_Stop(func);
            }
        }
    }
}


/***********************************************************************************************************************
* Function Name: spi10_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi10_interrupt(void *msg)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    SCIAFSelect_TypeDef func = SPI10_SCI;

    Sci_RegSetting(func);
    err_type = (uint8_t)(*sci_reg.SSR & SCI_OVERRUN_ERROR);
    *sci_reg.SIR = err_type;

    INTC_ClearPendingIRQ(sci_reg.IRQn);

    if (1U == err_type)
    {
        //error condition
    }
    else
    {
        if (pFrame->flag == INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    *sci_reg.SIO = *pFrame->data;
                    pFrame->data++;
                    pFrame->len--;
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if (((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) != 0) && ((*sci_reg.SCR & SCI_RECEPTION) != 0))
                    {
                        ;
                    }
                    else
                    {
                        while (*sci_reg.SSR & SCI_UNDER_EXECUTE)
                        {;}
                    }
                }

                SCI_SPI_Stop(func);
            }
        }

        if (pFrame->flag == INT_RX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                if ((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) == 0)
                {
                    *sci_reg.SIO = 0xFEU;   // dummy write in master reception mode
                }
            }
            else// if(pFrame->len == 1)
            {

                while ((*sci_reg.SSR & SCI_VALID_STORED) == 0)
                {
                    ;
                }

                //              if(0U != pFrame->data)
                //              {
                //                  *pFrame->data = *sci_reg.SIO;
                //                  pFrame->len--;
                //              }
                //              else
                //              {
                //                  sio_dummy = *sci_reg.SIO;
                //              }
                SCI_SPI_Stop(func);
            }
        }
    }
}

/***********************************************************************************************************************
* Function Name: spi11_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi11_interrupt(void *msg)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    SCIAFSelect_TypeDef func = SPI11_SCI;

    Sci_RegSetting(func);
    err_type = (uint8_t)(*sci_reg.SSR & SCI_OVERRUN_ERROR);
    *sci_reg.SIR = err_type;


    INTC_ClearPendingIRQ(sci_reg.IRQn);


    if (1U == err_type)
    {
        //error condition
    }
    else
    {
        if (pFrame->flag == INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    *sci_reg.SIO = *pFrame->data;
                    pFrame->data++;
                    pFrame->len--;
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if (((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) != 0) && ((*sci_reg.SCR & SCI_RECEPTION) != 0))
                    {
                        ;
                    }
                    else
                    {
                        while (*sci_reg.SSR & SCI_UNDER_EXECUTE)
                        {;}
                    }
                }

                SCI_SPI_Stop(func);
            }
        }

        if (pFrame->flag == INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                if ((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) == 0)
                {
                    *sci_reg.SIO = 0xFFU;   // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {

                while ((*sci_reg.SSR & SCI_VALID_STORED) == 0)
                {
                    ;
                }

                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                SCI_SPI_Stop(func);
            }
        }
    }
}
/***********************************************************************************************************************
* Function Name: spi2_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi20_interrupt(void *msg)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    SCIAFSelect_TypeDef func = SPI20_SCI;

    Sci_RegSetting(func);
    err_type = (uint8_t)(*sci_reg.SSR & SCI_OVERRUN_ERROR);
    *sci_reg.SIR = err_type;


    INTC_ClearPendingIRQ(sci_reg.IRQn);


    if (1U == err_type)
    {
        //error condition
    }
    else
    {
        if (pFrame->flag == INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    *sci_reg.SIO = *pFrame->data;
                    pFrame->data++;
                    pFrame->len--;
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if (((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) != 0) && ((*sci_reg.SCR & SCI_RECEPTION) != 0))
                    {
                        ;
                    }
                    else
                    {
                        while (*sci_reg.SSR & SCI_UNDER_EXECUTE)
                        {;}
                    }
                }

                SCI_SPI_Stop(func);
            }
        }

        if (pFrame->flag == INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                if ((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) == 0)
                {
                    *sci_reg.SIO = 0xFFU;   // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {

                while ((*sci_reg.SSR & SCI_VALID_STORED) == 0)
                {
                    ;
                }

                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                SCI_SPI_Stop(func);
            }
        }
    }
}

/***********************************************************************************************************************
* Function Name: spi21_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi21_interrupt(void *msg)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    SCIAFSelect_TypeDef func = SPI21_SCI;

    Sci_RegSetting(func);
    err_type = (uint8_t)(*sci_reg.SSR & SCI_OVERRUN_ERROR);
    *sci_reg.SIR = err_type;


    INTC_ClearPendingIRQ(sci_reg.IRQn);


    if (1U == err_type)
    {
        //error condition
    }
    else
    {
        if (pFrame->flag == INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    *sci_reg.SIO = *pFrame->data;
                    pFrame->data++;
                    pFrame->len--;
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if (((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) != 0) && ((*sci_reg.SCR & SCI_RECEPTION) != 0))
                    {
                        ;
                    }
                    else
                    {
                        while (*sci_reg.SSR & SCI_UNDER_EXECUTE)
                        {;}
                    }
                }

                SCI_SPI_Stop(func);
            }
        }

        if (pFrame->flag == INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                if ((*sci_reg.SMR & SCI_CLOCK_MODE_TI0N) == 0)
                {
                    *sci_reg.SIO = 0xFFU;   // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {

                while ((*sci_reg.SSR & SCI_VALID_STORED) == 0)
                {
                    ;
                }

                if (0U != pFrame->data)
                {
                    *pFrame->data = *sci_reg.SIO;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = *sci_reg.SIO;
                }

                SCI_SPI_Stop(func);
            }
        }
    }
}
