/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G127
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tim_demo.h"
#include "delay_demo.h"
#include "elc.h"
#include "common.h"
#include "dac_demo.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
    uint32_t msCnt;     // count value of 1ms
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);

//    Uart0_Init(19200);
//DAC real time output
		Dac_Init();
		msCnt = 0x100;
		while(msCnt--);
		ELC_Start(_09_ELC_EVENT_INTTM00,_05_ELC_EVENT_LINK_DAC);
		DAC_Mode(DAC_Mode_RealtimeOut); //set DAC to real mode
	
    /*Example1:Tim8 operates output square wave*/
		Tim8_SquareOutput();
		//change DAC output
		DAC_OutSet(0xff);
		
}




