/******************************************************************************
*
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd
.                    *
*                                                                              
*
*******************************************************************************
*
* FileName      : uart_demo.
c                                                  *
* Author        
:                                                              *
* Version       : 1.
0                                                          *
* Date          : 2021.08.
13                                                   *
* Description   
:                                                              *
* Function List 
:                                                              *
*******************************************************************************
*/
#include "uart_demo.h"
#include "dma_demo.h"

unsigned char UART0_RX_BUF[UART_MAX_RECV_LEN];
unsigned short UART0_RX_STA = 0;
unsigned char UART1_RX_BUF[UART_MAX_RECV_LEN];
unsigned short UART1_RX_STA = 0;
unsigned char UART2_RX_BUF[UART_MAX_RECV_LEN];
unsigned short UART2_RX_STA = 0;



/******************************************************************************
*****************************************
* Function Name: Uart0_Init
* @brief  UART0 init demo
* @param  bound
* @return init status
*******************************************************************************
****************************************/
int8_t Uart0_Init(uint32_t bound)
{
    int8_t ret;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    UART_InitTypeDef UART_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_9, GROUP_AF_TXD0);
    GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_10, GROUP_AF_RXD0);

    /*TX GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_9;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
		GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;	
    GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*RX GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_10 ;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*USART CONFIG*/
    UART_InitStructure.UART_BaudRate = bound;
    UART_InitStructure.UART_WordLength = UART_WordLength_8b;
    UART_InitStructure.UART_StopBits = UART_StopBits_1;//һֹͣλ
    UART_InitStructure.UART_Parity = UART_Parity_No;//żУλ
    UART_InitStructure.phase = UART_Phase_Normal;
    UART_InitStructure.bitorder = UART_Bit_LSB;
    UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx; //շģʽ

    ret = UART_Init(UART0, &UART_InitStructure); //ʼ

    if (ret)
    {
        SCI_ERROR_LOG(ret);
        return ret;
    }

    ISR_Register(ST0_IRQn, uart0_interrupt_send);     //0жϷ·ע
    ISR_Register(SR0_IRQn, uart0_interrupt_receive);  //0жϷ·ע

    return SCI_SUCCESS;
}
/******************************************************************************
*****************************************
* Function Name: uart1_init
* @brief  UART1 init
* @param  bound
* @return error or success
*******************************************************************************
****************************************/
int8_t Uart1_Init(uint32_t bound)
{
    int8_t res ;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    UART_InitTypeDef UART_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_2, GROUP_AF_TXD1);
    GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_3, GROUP_AF_RXD1);

    /*TX GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
		GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;	
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*RX GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*USART CONFIG*/
    UART_InitStructure.UART_BaudRate = bound;
    UART_InitStructure.UART_WordLength = UART_WordLength_8b;
    UART_InitStructure.UART_StopBits = UART_StopBits_1;//һֹͣλ
    UART_InitStructure.UART_Parity = UART_Parity_No;//żУλ
    UART_InitStructure.phase = UART_Phase_Normal;
    UART_InitStructure.bitorder = UART_Bit_LSB;
    UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx; //շģʽ

    res = UART_Init(UART1, &UART_InitStructure); //ʼ

    if (res)
    {
        SCI_ERROR_LOG(res);
        return res;
    }

    ISR_Register(ST1_IRQn, uart1_interrupt_send);     //1жϷ·ע
    ISR_Register(SR1_IRQn, uart1_interrupt_receive);  //1жϷ·ע

    return SCI_SUCCESS;
}

/******************************************************************************
*****************************************
* Function Name: uart2_init
* @brief  UART2 init
* @param  bound
* @return error or success
*******************************************************************************
****************************************/
int8_t Uart2_Init(uint32_t bound)
{
    int8_t res ;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    UART_InitTypeDef UART_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_0, GROUP_AF_TXD2);
    GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_1, GROUP_AF_RXD2);

    /*TX GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
		GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;	
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*RX GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*USART CONFIG*/
    UART_InitStructure.UART_BaudRate = bound;
    UART_InitStructure.UART_WordLength = UART_WordLength_8b;
    UART_InitStructure.UART_StopBits = UART_StopBits_1;//һֹͣλ
    UART_InitStructure.UART_Parity = UART_Parity_No;//żУλ
    UART_InitStructure.phase = UART_Phase_Normal;
    UART_InitStructure.bitorder = UART_Bit_LSB;
    UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx; //շģʽ

    res = UART_Init(UART2, &UART_InitStructure); //ʼ

    if (res)
    {
        SCI_ERROR_LOG(res);
        return res;
    }

    ISR_Register(ST2_IRQn, uart2_interrupt_send);     //2жϷ·ע
    ISR_Register(SR2_IRQn, uart2_interrupt_receive);  //2жϷ·ע

    //  Tim41_IntervalTimer();               //ʱ20ms
    //  TIM_Cmd(TIM41,TTM_Channel_0,Disable);//رնʱ
    return SCI_SUCCESS;
}

/******************************************************************************
*****************************************
* Function Name: Uart0_Send
* @brief  UART0 Send data
* @param  None
* @return None
*******************************************************************************
****************************************/
void Uart0_Send(uint8_t ch)
{
    UART_SendByte(UART0, ch);
}
/******************************************************************************
*****************************************
* Function Name: Uart0_Receive
* @brief  UART0 receive data
* @param  None
* @return rx data
*******************************************************************************
****************************************/
char Uart0_Receive(void)
{
    return UART_ReceiveByte(UART0);
}

/******************************************************************************
*****************************************
* Function Name: Uart0_IntSend
* @brief  UART0 Send data by interrupt
* @param  None
* @return None
*******************************************************************************
****************************************/
void Uart0_IntSend(uint8_t *tx_buf, uint16_t tx_num)
{
    pData.data = tx_buf;
    pData.len = tx_num;

    INTC_SetPendingIRQ(ST0_IRQn);
}

/****************************************************************************
* Function Name: uart0_dma_send
* @brief  UART0 Send interrupt service routine
* @param  None
* @return None
*****************************************************************************/

//void Uart0_Dma_Send(uint8_t *tx_buf, uint16_t tx_num)
//{
//	uint8_t temp;
//	DMA_Uart0_Tx(DMA_VECTOR_ST0, DMA_Mode_Normal, (void *)(tx_buf+1), (void *)&UART0_TX, tx_num); //config dma transmission
//	Uart0_Send(tx_buf[0]);

//}

/******************************************************************************
*****************************************
* Function Name: uart0_interrupt_send
* @brief  UART0 Send interrupt service routine
* @param  None
* @return None
*******************************************************************************
****************************************/
void uart0_interrupt_send(void *msg)
{
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    INTC_ClearPendingIRQ(ST0_IRQn);

    if ((pFrame->len > 0U) && pFrame->data)
    {
        UART0_TX = *pFrame->data;
        pFrame->data++;
        pFrame->len --;
    }
    else //send finished
    {
    }
}

/****************************************************************************
* Function Name: Uart0_Dma_Rcv
* @brief  UART0 dma receive data using ringr buffer
* @param  buf
* @return read buff length
*****************************************************************************/
uint8_t Uart0_Dma_Rcv(uint8_t *buf)
{
    static uint16_t read = 0, write = 0;
    static uint16_t raw_len = UART_MAX_RECV_LEN;
    int16_t readlen = 0;
		read = 0;
    if (buf == NULL)
    {
        return 0;
    }

    write = raw_len - DMA_TRANS_TIMES;  //дָλ
    readlen = write - read;                   //ݳ

    if (!readlen)
    {
        return 0;
    }

    if (readlen  < 0)
    {
        readlen += raw_len;
    }

    if (readlen < (raw_len - read))     //۷
    {
        memcpy(buf, &UART0_RX_BUF[read], readlen);
    }
    else
    {
        memcpy(buf, &UART0_RX_BUF[read], raw_len - read);
        memcpy(&buf[raw_len - read], UART0_RX_BUF, readlen - (raw_len - read));
    }

    read = (readlen + read) % raw_len; //¶ָ
    return readlen;
}

/******************************************************************************
*****************************************
* Function Name: uart_callback_error
* @brief
* @param  None
* @return None
*******************************************************************************
****************************************/
void uart_callback_error(uint8_t err_type)
{
    //user edit here when appear error
}

/******************************************************************************
*****************************************
* Function Name: uart0_interrupt_receive
* @brief  UART0 Receive interrupt service routine
* @param  None
* @return None
*******************************************************************************
****************************************/
void uart0_interrupt_receive(void *msg)
{
    volatile uint8_t rx_data;
    volatile uint8_t err_type;


    INTC_ClearPendingIRQ(SR0_IRQn);
    err_type = UART_GetErrStaus(UART0, UART_FLAG_FEF | UART_FLAG_PEF | 
UART_FLAG_OVF);

    if (err_type)
    {
        uart_callback_error(err_type);
    }

    rx_data = UART0_RX;

#ifndef UART0_DMA_RCV

    if ((UART0_RX_STA & 0x8000U) == 0) //δ
    {
        if (UART0_RX_STA & 0x4000U) //յ0x0d
        {
            if (rx_data != 0x0a)
			{
				UART1_RX_BUF[UART1_RX_STA & 0x3fff] = rx_data;
				UART1_RX_STA++; 			
			}
            else
            {
                UART0_RX_STA |= 0x8000;
                UART0_RX_BUF[UART0_RX_STA & 0x3fff] = rx_data;
                UART0_RX_STA ++;
            }
        }
        else                     //δյ0x0d
        {
            if (rx_data == 0x0d)
            {
                UART0_RX_STA |= 0x4000;
                UART0_RX_BUF[UART0_RX_STA & 0x3fff] = rx_data;
                UART0_RX_STA ++;
            }
            else
            {
                UART0_RX_BUF[UART0_RX_STA & 0x3fff] = rx_data;
                UART0_RX_STA ++;
            }
        }
    }
    else if ((UART0_RX_STA & 0x8000U) == 1) // receive finished
    {
    }

#else
    //  UART0_RX_STA|=1<<15;                    //ǿƱǽ
#endif
}

/******************************************************************************
*****************************************
* Function Name: Uart1_IntSend
* @brief  UART1 Send data by interrupt
* @param  None
* @return None
*******************************************************************************
****************************************/
void Uart1_IntSend(uint8_t *tx_buf, uint16_t tx_num)
{
    pData.data = tx_buf;
    pData.len = tx_num;

    INTC_SetPendingIRQ(ST1_IRQn);
}
/******************************************************************************
*****************************************
* Function Name: uart1_interrupt_send
* @brief  UART1 Send interrupt service routine
* @param  None
* @return None
*******************************************************************************
****************************************/
void uart1_interrupt_send(void *msg)
{
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;

    INTC_ClearPendingIRQ(ST1_IRQn);

    if ((pFrame->len > 0U) && pFrame->data)
    {
        UART1_TX = *pFrame->data;
        pFrame->data++;
        pFrame->len --;
    }
    else  //send finished
    {
    }
}
/******************************************************************************
*****************************************
* Function Name: Uart1_IntRcv
* @brief  UART1 Receive data by interrupt
* @param  None
* @return rx_num
*******************************************************************************
****************************************/
int  Uart1_IntRcv(uint8_t *rx_buf)
{
    uint32_t rx_num = 0;

    if ((UART1_RX_STA & 0x8000U) == 1)
    {
        rx_num = UART1_RX_STA & 0x3fff;
        memcpy(rx_buf, UART1_RX_BUF, rx_num);
        return rx_num;
    }

    return 0;
}
/******************************************************************************
*****************************************
* Function Name: uart1_interrupt_receive
* @brief  UART1 Receive interrupt service routine
* @param  None
* @return None
*******************************************************************************
****************************************/
void uart1_interrupt_receive(void *msg)
{
    volatile uint8_t rx_data;
    volatile uint8_t err_type;


    INTC_ClearPendingIRQ(SR1_IRQn);
    err_type = UART_GetErrStaus(UART1, UART_FLAG_FEF | UART_FLAG_PEF | 
UART_FLAG_OVF);

    if (err_type)
    {
        uart_callback_error(err_type);
    }

    rx_data = UART1_RX;

    if ((UART1_RX_STA & 0x8000U) == 0) //δ
    {
        if (UART1_RX_STA & 0x4000U) //յ0x0d
        {
            if (rx_data != 0x0a)
			{
				UART1_RX_BUF[UART1_RX_STA & 0x3fff] = rx_data;
				UART1_RX_STA++; 			
			}
            else
            {
                UART1_RX_STA |= 0x8000;
                UART1_RX_BUF[UART1_RX_STA & 0x3fff] = rx_data;
                UART1_RX_STA ++;
            }
        }
        else                     //δյ0x0d
        {
            if (rx_data == 0x0d)
            {
                UART1_RX_STA |= 0x4000;
                UART1_RX_BUF[UART1_RX_STA & 0x3fff] = rx_data;
                UART1_RX_STA ++;
            }
            else
            {
                UART1_RX_BUF[UART1_RX_STA & 0x3fff] = rx_data;
                UART1_RX_STA ++;
            }
        }
    }
    else if ((UART1_RX_STA & 0x8000U) == 1) //received finished
    {
    }
}

/******************************************************************************
*****************************************
* Function Name: Uart2_IntSend
* @brief  UART2 Send data by interrupt
* @param  None
* @return None
*******************************************************************************
****************************************/
void Uart2_IntSend(uint8_t *tx_buf, uint16_t tx_num)
{
    pData.data = tx_buf;
    pData.len = tx_num;

    INTC_SetPendingIRQ(ST2_IRQn);
}

/******************************************************************************
*****************************************
* Function Name: uart2_interrupt_send
* @brief  UART2 Send interrupt service routine
* @param  None
* @return None
*******************************************************************************
****************************************/
void uart2_interrupt_send(void *msg)
{
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;

    INTC_ClearPendingIRQ(ST2_IRQn);

    if ((pFrame->len > 0U) && pFrame->data)
    {
        UART2_TX = *pFrame->data;
        pFrame->data++;
        pFrame->len --;
    }
    else  //send finished
    {
    }
}
/******************************************************************************
*****************************************
* Function Name: uart2_interrupt_receive
* @brief  UART2 Receive interrupt service routine
* @param  None
* @return None
*******************************************************************************
****************************************/
void uart2_interrupt_receive(void *msg)
{
    volatile uint8_t rx_data;
    volatile uint8_t err_type;


    INTC_ClearPendingIRQ(SR2_IRQn);
    err_type = UART_GetErrStaus(UART2, UART_FLAG_FEF | UART_FLAG_PEF | 
UART_FLAG_OVF);

    if (err_type)
    {
        uart_callback_error(err_type);
    }

    rx_data = UART2_RX;

    if ((UART2_RX_STA & (1 << 15)) == 0)
    {
        if (UART2_RX_STA < UART_MAX_RECV_LEN)
        {
            //          TIM_SetCounter(TIM41,TTM_Channel_0,20); 
//ʱʱ¼ʼĬΪ20Ϊ20
            //          TIM_Cmd(TIM41,TTM_Channel_0,Enable);  //
            UART2_RX_BUF[UART2_RX_STA++] = rx_data;
        }
        else
        {
            UART2_RX_STA |= 1 << 15;                //ǿƱǽ
        }
    }
}
